/*
   easyopen User Monitor
   Javascript to open a websocket to the server.
   This receives activity updates from the easyopen database, via server, 
   and posts the updated information to the HTML page for display by the web browser.
*/

var receivedMessages = null;
var StatusLine = null;
var ui_UserName = null;
var ui_Time = null;
var ui_Rdr = null;
var ui_PhotoID = null;
var ui_Info = null;


// the URL of the WAMP Router (Crossbar.io)
//
var wsuri;
if (document.location.origin == "file://") {
   wsuri = "ws://127.0.0.1:8080/ws";

} else {
   wsuri = (document.location.protocol === "http:" ? "ws:" : "wss:") + "//" +
               document.location.host + "/ws";
}


// the WAMP connection to the Router
//
var connection = new autobahn.Connection({
   url: wsuri,
   realm: "coastform"
});


// fired when connection is established and session attached
//
connection.onopen = function (session, details) {

   console.log("Connected");

   // SUBSCRIBE to a topic and receive events
   //
   function on_counter (args) 
   {
      var counter = args[0];
      console.log("Counter msg: " + counter);
   }
   var subsTopic = 'coastform.eousermon.useractivity';
   session.subscribe(subsTopic, onMessage).then(
      function (sub) {
         console.log('subscribed to ', subsTopic);
      },
      function (err) {
         console.log('failed to subscribe to topic', err);
      }
   );

//   ui_Info = document.getElementById('id_info');
//   ui_Info.innerHTML = "";

   ui_UserName = document.getElementById('id_username');
   ui_UserName.innerHTML = "Name";

   ui_Time = document.getElementById('id_timedate');
   ui_Time.innerHTML = "Time";

   ui_Rdr = document.getElementById('id_rdr_name');
   ui_Rdr.innerHTML = "Presence Unknown";

   ui_PhotoID = document.getElementById('id_PhotoID');
   ui_PhotoID.innerHTML = "";

   
//   updateStatusline("Connected to " + wsuri);
   session.publish('com.eousermon.onhello', ['Hello from Coastform user monitor (browser)']);


};

function onMessage(args, kwargs, details) {
   var tup_Msg = args[0];
   var str_uname = "";
   var str_PathToPhotoID = "";
   var str_timePrefix = ""
   var str_time = "";
   var str_door = "";
   var str_rdr = "";
   console.log("Msg event: " + tup_Msg);
   
//   ui_Info.innerHTML = tup_Msg;
   [str_uname, str_PathToPhotoID, str_time, str_door, str_rdr] = tup_Msg;
   ui_UserName.innerHTML = str_uname;
   ui_Time.innerHTML = str_time;
   ui_Rdr.innerHTML = str_rdr;
   ui_PhotoID.src = str_PathToPhotoID;
   if(str_rdr == "IN")
   {
      str_timePrefix = "In at:"
   }
   else if(str_rdr == "OUT")
   {
      str_timePrefix = "Out at:"
   }
   else
   {
      str_timePrefix = "At:"
   }
   ui_time_prefix.innerHTML = str_timePrefix;

}

function updateStatusline(status) {
//   $(".statusline").text(status);
//   StatusLine.value = status;
   StatusLine.innerHTML = status;
};


// fired when connection was lost (or could not be established)
//
connection.onclose = function (reason, details) {
   console.log("Connection lost: " + reason);
}


// now actually open the connection
//
connection.open();
